local metadata = {
"## Interface:FS15 1.2",
"## Title: TriggerExtend",
"## Notes: Setzt/Aendert Werte in Triggers",
"## Author: HappyLooser",
"## Version: 0.2",
"## Date: 02.02.2015",
"## Web: no",
"## Info: Änderungen,Kopien oder Code Benutzung ist ohne meine Zustimmung nicht erlaubt"
}

TriggerExtend = {};
TriggerExtendMP = true;
TriggerExtendMPUpdate = false;
local pathSavegame;
local stationNames = "(TriggerExtend)sell station names: ";
local stationUpdateNames = "";
local start = true;
local Xml;
TriggerExtendXml = "";

function TriggerExtendLoad()	
	print("---loading TriggerExtend v0.2 (by HappyLooser)---")	
	local path = getUserProfileAppPath();		
	local file = path.."/triggerExtendSettings.xml";		
	if g_server ~= nil and g_client ~= nil then		
		if fileExists(file) then
			print("loading "..file.." for TriggerExtend settings");		
			Xml = loadXMLFile("triggerExtendSettings_XML", file, "Trigger");
		else
			print("creating "..file.." for SellTriggerExtend settings");
			Xml = createXMLFile("triggerExtendSettings_XML", file, "Trigger");		
			setXMLString(Xml, "Trigger.SellTrigger.StationFreightYard", "silage:0.45,forage_mixing:0.8,deleteOld:false");				
		end;
		saveXMLFile(Xml);	
		Xml = loadXMLFile("triggerExtendSettings_XML", file, "Trigger");		
	end;	
end;

function getSellTypes(self, sellTypes)
	if sellTypes == nil or string.len(sellTypes) <= 2 then return false;end;
	local types = Utils.splitString(",", sellTypes);
	if types == nil then return false;end;
	local sellPrice = "";
	local sellType = "";
	local deleteOld = false;
	if string.find(sellTypes, "deleteOld:true") then deleteOld = true;end;
	for k,v in pairs(types) do
		if string.find(v, "deleteOld:") == nil then			
			if string.find(v, ":") == nil then				
				if string.len(sellType) >= 2 then sellType = sellType.. " ".. v;end;
				if string.len(sellPrice) >= 1 then sellPrice = sellPrice.. " 0.25";end;
				if string.len(sellType) == 0 then sellType = sellType.. v;end;
				if string.len(sellPrice) == 0 then sellPrice = sellPrice.. "0.25";end;
			else
				local typeAndPrice = Utils.splitString(":", v);
				if typeAndPrice ~= nil then
					if string.len(sellType) >= 2 then sellType = sellType.. " ".. typeAndPrice[1];end;
					if string.len(sellType) == 0 then sellType = sellType.. typeAndPrice[1];end;	
					if string.len(sellPrice) >= 1 then sellPrice = sellPrice.. " ".. typeAndPrice[2];end;
					if string.len(sellPrice) == 0 then sellPrice = sellPrice.. typeAndPrice[2];end;
				end;				
			end;			
		end;		
	end;	
	return sellType, sellPrice, deleteOld
end;

function table.val_to_str(v)
  if "string" == type(v) then
    v = string.gsub(v, "\n", "\\n");
    if string.match(string.gsub(v,"[^'\"]",""), '^"+$') then
      return "'" .. v .. "'";
    end;
    return '"' .. string.gsub(v,'"', '\\"') .. '"';
  else
    return "table" == type(v) and table.tostring(v) or tostring(v);
  end;
end;

function table.key_to_str(k)
  if "string" == type(k) and string.match(k, "^[_%a][_%a%d]*$") then
    return k;
  else
    return "[" .. table.val_to_str(k) .. "]";
  end;
end;

function table.tostring(tbl)
  local result, done = {}, {};
  for k,v in ipairs(tbl) do
    table.insert(result, table.val_to_str(v));
    done[k] = true;
  end;
  for k,v in pairs(tbl) do
    if not done[k] then
      table.insert(result, table.key_to_str(k) .. "=" .. table.val_to_str(v));
    end;
  end;
  return "{" .. table.concat( result, "," ) .. "}";
end

function TriggerExtend:loadMap(xmlFile)	
	local dir = g_currentMission.missionInfo:getSavegameDirectory(g_currentMission.missionInfo.savegameIndex);
	pathSavegame = dir;
	TriggerExtendLoad();	
	if g_server ~= nil and g_client ~= nil then		
		synTriggers(true, false, nil);
	end;
	self.setExtendTrigger = TriggerExtendXml;
	self.loginEvent = false;	
end;

function TriggerExtend:deleteMap()
	TriggerExtendMP = true;
	TriggerExtendMPUpdate = false;
end;

function TriggerExtend:mouseEvent(posX, posY, isDown, isUp, button)	
end;

function TriggerExtend:keyEvent(unicode, sym, modifier, isDown)	
end;

function TriggerExtend:updateTick(dt)			
end;

function TriggerExtend:update(dt)
	if g_server == nil and TriggerExtendMP then		
		TriggerExtendMP = false;
		TriggerExtendEvent.sendEvent(self.setExtendTrigger, true);
	end;
end;

function TriggerExtend:draw(dt)
end;
addModEventListener(TriggerExtend);

TriggerExtendEvent = {};
TriggerExtendEvent_mt = Class(TriggerExtendEvent, Event);
InitEventClass(TriggerExtendEvent, "TriggerExtendEvent");

function TriggerExtendEvent:emptyNew()    
	local self = Event:new(TriggerExtendEvent_mt );
    self.className="TriggerExtendEvent";
    return self;
end;

function TriggerExtendEvent:new(triggerNew, noEventSend)    	
	local self = TriggerExtendEvent:emptyNew();
	self.setExtendTrigger = triggerNew;	
	self.loginEvent = noEventSend;	
    return self;
end;

function TriggerExtendEvent:readStream(streamId, connection)    
	self.setExtendTrigger = streamReadString(streamId);  
    self.loginEvent = streamReadBool(streamId);	
	self:run(connection);
end;

function TriggerExtendEvent:writeStream(streamId, connection)    	
	streamWriteString(streamId, self.setExtendTrigger);
	streamWriteBool(streamId, self.loginEvent); 
end;

function TriggerExtendEvent:run(connection)
	if self.setExtendTrigger ~= nil and not self.loginEvent and not TriggerExtendMPUpdate then		
		self.setExtendTrigger = self.setExtendTrigger;		
		self:setExtendTriggersEvent(self.setExtendTrigger, true);		
	end;
	if self.loginEvent and not TriggerExtendMPUpdate then		
		self.setExtendTrigger = TriggerExtendXml;
		TriggerExtendEvent.sendEvent(self.setExtendTrigger, false)	
	end;
end;

function TriggerExtendEvent.sendEvent(triggerNew, noEventSend)		
	if g_server ~= nil and g_server ~= false and not noEventSend then		
		g_server:broadcastEvent(TriggerExtendEvent:new(triggerNew, false), nil, nil, nil);		
	end;
	if g_server == nil and noEventSend then		
		g_client:getServerConnection():sendEvent(TriggerExtendEvent:new(triggerNew, true));
	end;
end;


function TriggerExtendEvent:setExtendTriggersEvent(triggersNew, noEventSend)	
	if triggersNew ~= nil then		
		synTriggers(false, true, triggersNew)
		TriggerExtendMPUpdate = true;
		g_currentMission.inGameMessage:showMessage("TriggerExtend", "update Sell Triggers:\n".. stationUpdateNames, 4000, false);				
	end;
end;

function synTriggers(isServer, isClient, triggersNew)
	if start then		
		for k,tipTrigger in pairs(g_currentMission.tipTriggers) do			
			local stationName = getUserAttribute(tipTrigger.triggerId, "stationName");		
			if stationName ~= nil then
				local id = tipTrigger.triggerId;
				--print("test return true:".. stationName)
				local fillTypes = getUserAttribute(id, "fillTypes");
				local priceMultipliersString = getUserAttribute(id, "priceMultipliers");
				if fillTypes == nil then
					fillTypes = getUserAttribute(id, "fruitTypes");
				end
				if isServer then					
					if priceMultipliersString ~= nil then						
						print(stationNames.. stationName.. "(".. fillTypes.. ")".. priceMultipliersString );						
					else						
						if fillTypes ~= nil then
							print(stationNames.. stationName.. "(".. fillTypes.. ") !!Warning!! Prices not found at station?");
						else
							print(stationNames.. stationName.. "(!!Warning!! FillTypes and prices not found at station?)");
						end;
					end;
				end;				
				if tipTrigger.priceMultipliers ~= nil or tipTrigger.acceptedFillTypes ~= nil then												
					local sellTypes = "";
					local sellPrices = 0;
					local deleteOldTypes = false;
					if isServer then
						if getXMLString(Xml, "Trigger.SellTrigger.".. stationName) ~= nil then
							TriggerExtendXml = TriggerExtendXml ..stationName .." " ..getXMLString(Xml, "Trigger.SellTrigger.".. stationName) ..";";						
							local foundSellTypes, foundSellPrices, foundDeleteOld = getSellTypes(tipTrigger, getXMLString(Xml, "Trigger.SellTrigger.".. stationName));
							if foundSellTypes ~= nil then
								sellTypes = foundSellTypes;
								sellPrices = foundSellPrices;
								deleteOldTypes = foundDeleteOld;
							end;						
						end;
					end;
					if isClient and triggersNew ~= nil then					
						if string.find(triggersNew, stationName .." ") ~= nil then
							local serverTriggers = Utils.splitString(";", triggersNew);							
							for k,v in pairs(serverTriggers) do
								if string.find(v, stationName) ~= nil then
									serverTriggers = string.gsub(v, stationName.. " ", "")
									local languageStationName = g_i18n:getText(tipTrigger.stationName)
									stationUpdateNames = stationUpdateNames.. " ".. languageStationName;
									break;
								end;
							end;
							local foundSellTypes, foundSellPrices, foundDeleteOld = getSellTypes(tipTrigger, serverTriggers);
							if foundSellTypes ~= nil then
								sellTypes = foundSellTypes;
								sellPrices = foundSellPrices;
								deleteOldTypes = foundDeleteOld;
							end;						
						end;
					end;
					if deleteOldTypes then
						local types = Utils.splitString(" ", fillTypes);
						local multipliers = Utils.splitString(" ", priceMultipliersString);
						for k,v in pairs(types) do
							local desc = Fillable.fillTypeNameToDesc[v];
							if desc ~= nil then									
								tipTrigger.acceptedFillTypes[desc.index] = nil;
								tipTrigger.priceMultipliers[desc.index] = nil;
							end;
						end;
						if string.len(sellTypes) >= 2 then							
							fillTypes = sellTypes;
							if string.len(sellPrices) >= 2 and sellPrices ~= 0 then
								priceMultipliersString = sellPrices;
							end;
						end;
					else
						if string.len(sellTypes) >= 2 then							
							fillTypes = fillTypes.. " ".. sellTypes;
							if string.len(sellPrices) >= 2 and sellPrices ~= 0 then
								priceMultipliersString = priceMultipliersString.. " ".. sellPrices;
							end;
						end;
					end;											
					local types = Utils.splitString(" ", fillTypes);
					local multipliers = Utils.splitString(" ", priceMultipliersString);
					for k,v in pairs(types) do
						local desc = Fillable.fillTypeNameToDesc[v];
						if desc ~= nil then								
							tipTrigger.acceptedFillTypes[desc.index] = true;																
							tipTrigger.priceMultipliers[desc.index] = tonumber(multipliers[k]);	
							if tipTrigger.priceMultipliers[desc.index] == nil then
								tipTrigger.priceMultipliers[desc.index] = Utils.getNoNil(tipTrigger.defaultPriceMultiplier, 0);
								if not tipTrigger.isFarmTrigger and tipTrigger.defaultPriceMultiplier == nil then
									print("Error: "..k.."th priceMultiplier is invalid in TipTrigger "..getName(id));
								end;
							end;								
						end;
					end;								
					tipTrigger.isEnabled = true;
					tipTrigger.tipTriggerDirtyFlag = tipTrigger:getNextDirtyFlag();
					--return true;
				end;
			end;				
		end;		
	end;
end;